/*
 * MPQCFragmentController.hpp
 *
 *  Created on: Aug 27, 2012
 *      Author: heber
 */

#ifndef MPQCFRAGMENTCONTROLLER_HPP_
#define MPQCFRAGMENTCONTROLLER_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Fragmentation/Automation/SpecificFragmentController.hpp"

#include <boost/filesystem/path.hpp>

#include <fstream>
#include <string>
#include <vector>

#include "JobMarket/types.hpp"

#include "Fragmentation/Containers/MPQCData.hpp"

/** This class uses SpecificFragmentController with functions to add specificly
 * VMGJobs.
 */
class MPQCFragmentController : public SpecificFragmentController
{
public:
  MPQCFragmentController(boost::asio::io_service &io_service) :
    SpecificFragmentController(io_service)
  {}
  virtual ~MPQCFragmentController()
  {}

  /** Command Controller to fill its hold of jobs from FragmentJobQueue.
   *
   * \param _DoSampleDensity whether to actually sample the resulting electronic density
   * \return true - jobs obtained, false - queue empty
   */
  bool addJobsFromQueue(const MPQCData::DoLongrange_t _DoLongrange);

  /** Get results map of calculated jobs.
   *
   * \param fragmentData contains map of results on output
   */
  void getResults(std::map<JobId_t, MPQCData> &fragmentData) {
    SpecificFragmentController::getResults<MPQCData>(fragmentData);
  }

  /** Runs the service.
   *
   * Here, we finalize each job's id and push them to the server.
   */
  void run();
};


#endif /* MPQCFRAGMENTCONTROLLER_HPP_ */
